{*
Copyright (c) 2007 Cary Jensen. All rights reserved.

This code sample is associated with the presentation
"Building Abstract Data Layers for ASP.NET Applications"
by Cary Jensen, Jensen Data Systems, Inc.

presented at CodeRage 2007, Tuesday, March 13 2007


This code sample is provided for demonstration purposes only

No guarantees or warranties are expressed or implied concerning
the applicability of techniques or code included in this code
sample. If you wish to use techniques or code included in this
code sample, it is your responsibility to test and certify any
code, techniques, or designs adopted as a result of this code sample

For information about training or consulting services
for all versions of Delphi, please visit
http://www.JensenDataSystems.com


*}
unit DataForm;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  JDSI.Modules.SqlDataModule, SysUtils;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure TWebForm1_Unload(sender: System.Object; e: System.EventArgs);
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    CustomerDropDown: System.Web.UI.WebControls.DropDownList;
    Button1: System.Web.UI.WebControls.Button;
    ErrorMessageLabel: System.Web.UI.WebControls.Label;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
    SqlDataModule: TSqlDataModule;
  public
    { Public Declarations }
  end;

implementation

resourcestring
  SELECTCompany = '-- SELECT a Company --';

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.Button1.Click, Self.Button1_Click);
  Include(Self.Unload, Self.TWebForm1_Unload);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  // TODO: Put user code to initialize the page here
  if not IsPostBack then
  begin
    CustomerDropDown.DataSource := SqlDataModule.ExecuteDataReader('select CustomerID, CompanyName FROM Customers');
    CustomerDropDown.DataTextField := 'CompanyName';
    CustomerDropDown.DataValueField := 'CustomerID';
    DataBind;
    CustomerDropDown.Items.Insert(0, SELECTCompany);
  end;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  // Validation
  SqlDataModule := TSqlDataModule.Create(Request, Response, Session, Trace);
  SqlDataModule.VerifyLogin;
  InitializeComponent;
  inherited OnInit(e);
 end;

procedure TWebForm1.Button1_Click(sender: System.Object; e: System.EventArgs);

begin
  if CustomerDropDown.SelectedItem.Text = SELECTCompany then
  begin
     ErrorMessageLabel.Text := 'Please select a company';
     Exit;
  end;
  Response.Redirect('custpage.aspx?cust=' + CustomerDropDown.SelectedValue);
end;

procedure TWebForm1.TWebForm1_Unload(sender: System.Object; e: System.EventArgs);
begin
  SqlDataModule.Dispose;
end;

end.

